<?php

/*
рабочее название проекта Nginx-CPL - nginx CPanel LiO

анализ конфига apache и формирования конфигов для nginx
модификация от 12.01.2019

записывает в мемкеш количество сайтов из конфига
для дальшейнего показа на страницах сайта хостинга

*/

// удаление перевода строки
function UdaleniePerehoda($s)
{
        return preg_replace('/\r\n|\r|\n/u', '', $s);
}

// обновление файлов конфига
function GoMain()
{
        $log.=date("m.d.y").' '.date("H:i:s").': nachalo'."\n";
        // читаем конфиг apache
        if (file_exists(APACHE_CONF) && is_readable(APACHE_CONF))
        {
                // удаляем старые конфиг файлы
                exec(' rm -Rf '.NGINX_CONF.'*cpl.conf');                
                $a_file = file_get_contents(APACHE_CONF);
                // анализ текста для HTTP
                $r = "#\<VirtualHost [0-9a-f\.\:\[\]\s]+\:".APACHE_PORT_HTTP."\>(.+?)\<\/VirtualHost\>#s";
                preg_match_all($r, $a_file, $mat, PREG_PATTERN_ORDER);
                $cnt=count($mat[1]);
                $log.=date("m.d.y").' '.date("H:i:s").': obrabotan parser http ( '.$cnt.'sites)'."\n";
                $go=0;        
                // запись в мемкеш ---------
                // echo $cnt;
                // ---------- запись в мемкеш
                if ($cnt) 
                {
                        // echo "\n";      
                        $go=1;
                        foreach ($mat[0] as $virthost)
                        {
                                // listen
                                $listen = NGINX_PORT_HTTP;
                                // server_name и proxy_pass_host для раздела  $proxy_pass
                                preg_match("#ServerName (.+?)\n#s", $virthost, $server_name_o);
                                preg_match("#ServerAlias (.+?)\n#s", $virthost, $server_name_a);                                                 
                                $proxy_pass_host=UdaleniePerehoda($server_name_o[1]);
                                $server_name=$proxy_pass_host.' '.UdaleniePerehoda($server_name_a[1]);
                                // root 
                                preg_match("#DocumentRoot (.+?)\n#s", $virthost, $root_);
                                $root=UdaleniePerehoda($root_[1]);
                                // proxy_pass
                                preg_match("#<VirtualHost (.+?):#s", $virthost, $ip_);
                                $ip=$ip_[1];
                                $proxy_pass='http://'.$ip.':'.APACHE_PORT_HTTP;
        //                        $proxy_pass='http://178.91.94.9:'.APACHE_PORT_HTTP;
                                $out_http='# http '.date("m.d.y").' '.date("H:i:s").' '."\n".
                                        'server {'."\n".
                                        '        listen '.$listen.';'."\n".
                                        '        server_name '.$server_name.';        '."\n".
                                        '        root '.$root.';'."\n".
                                        "\n".
                                '        location ~*.*\.(3gp|gif|jpg|jpeg|png|ico|wmv|avi|asf|asx|mpg|mpeg|mp4|pls|mp3|mid|wav|swf|flv|html|htm|txt|js|css|exe|zip|tar|rar|gz|tgz|bz2|uha|7z|doc|docx|xls|xlsx|pdf|iso)$ '."\n".
                                        '        {'."\n".
                                   '                expires 1M;'."\n".
                                   '                try_files $uri @backend;'."\n".
                                        '        }'."\n".
                                        "\n".
                                '        location / '."\n".
                                        '        {'."\n".
                                   '                error_page 405 = @backend;'."\n".
                                        // '#           add_header X-Cache "HIT from Backend";'."\n".
                                   '                proxy_pass '.$proxy_pass.';'."\n".
                                   '                include "/etc/nginx/proxy/proxy.inc";'."\n".
                                   '                include "/etc/nginx/proxy/microcache.inc";'."\n".
                                        '        }'."\n".
                                        "\n".
                                '        location @backend '."\n".                        
                                        '        {'."\n".
                                   '                internal;'."\n".
                                   '                proxy_pass '.$proxy_pass.';'."\n".
                                   '                include "/etc/nginx/proxy/proxy.inc";'."\n".
                                   '                include "/etc/nginx/proxy/microcache.inc";'."\n".
                                '        }'."\n".
                                        "\n".
                                '        location ~ .*\.(php|jsp|cgi|pl|py)?$ '."\n".
                                        '        {'."\n".
                                   '                proxy_pass '.$proxy_pass.';'."\n".
                                   '                include "/etc/nginx/proxy/proxy.inc";'."\n".
                                   '                include "/etc/nginx/proxy/microcache.inc";'."\n".
                                        '        }'."\n".
                                        
                                        '   error_page 404 /404.html;'."\n".
                                        '       location = /40x.html {'."\n".
                                        '        }'."\n".
                                        "\n".
                                        '   error_page 500 502 503 504 /50x.html;'."\n".
                                        '        location = /50x.html {'."\n".
                                        '   }'."\n".                                        
                                        '}'."\n";
                        
                                file_put_contents(NGINX_CONF.$proxy_pass_host.'.http-cpl.conf', $out_http);
                        
                                $log.=date("m.d.y").' '.date("H:i:s").': done = '.$proxy_pass_host."\n";
                        
                                // echo "\n----------------\n";
                        
                                // echo $virthost;                        
                        
                        //        exit;
                        }
                // цикл анализа текста для HTTPs
                //echo "\n";
        }
                
        // анализ текста для HTTPs
    $r = "#\<VirtualHost [0-9a-f\.\:\[\]\s]+\:".APACHE_PORT_HTTPS."\>(.+?)\<\/VirtualHost\>#s";                
    preg_match_all($r, $a_file, $mat, PREG_PATTERN_ORDER);
        $cnt=count($mat[1]);
        $log.=date("m.d.y").' '.date("H:i:s").': obrabotan parser https ('.$cnt.' sites)'."\n";
    if ($cnt) 
        {
                //echo "\n";      
                $go=1;
                foreach ($mat[0] as $virthost) 
                {
                        // listen
                        $listen = NGINX_PORT_HTTPS;
                        // server_name и proxy_pass_host для раздела  $proxy_pass
                        preg_match("#ServerName (.+?)\n#s", $virthost, $server_name_o);
                        preg_match("#ServerAlias (.+?)\n#s", $virthost, $server_name_a);                                                 
                        $proxy_pass_host=UdaleniePerehoda($server_name_o[1]);
                        $server_name=$proxy_pass_host.' '.UdaleniePerehoda($server_name_a[1]);
                        // root 
                        preg_match("#DocumentRoot (.+?)\n#s", $virthost, $root_);
                        $root=UdaleniePerehoda($root_[1]);
                        // proxy_pass
                        preg_match("#<VirtualHost (.+?):#s", $virthost, $ip_);
                        $ip=$ip_[1];
                        $proxy_pass='https://'.$ip.':'.APACHE_PORT_HTTPS;                        
                        // $proxy_pass='https://'.$proxy_pass_host.':'.APACHE_PORT_HTTPS;
        //                $proxy_pass='https://178.91.94.9:'.APACHE_PORT_HTTPS;
                        
                        // SSLCertificateFile
                        preg_match("#SSLCertificateFile (.+?)(\n|\r)#s", $virthost, $ssl_certificate_);
                        $ssl_certificate=UdaleniePerehoda($ssl_certificate_[1]);
                        $ssl_certificate_key=$ssl_certificate;
                        
                        $out_https='# http '.date("m.d.y").' '.date("H:i:s").' '."\n".
                                        'server {'."\n".
                                        '        listen '.$listen.' ssl http2;'."\n".
                                        '        server_name '.$server_name.';        '."\n".
                                        '        root '.$root.';'."\n".
                                        
                                        "\n".
                                        
                                        '        ssl_certificate '.$ssl_certificate.';'."\n".
                                        '        ssl_certificate_key '.$ssl_certificate_key.';'."\n".
                                        
                                        "\n".
                                '        location ~*.*\.(3gp|gif|jpg|jpeg|png|ico|wmv|avi|asf|asx|mpg|mpeg|mp4|pls|mp3|mid|wav|swf|flv|html|htm|txt|js|css|exe|zip|tar|rar|gz|tgz|bz2|uha|7z|doc|docx|xls|xlsx|pdf|iso)$ '."\n".
                                        '        {'."\n".
                                   '                expires 1M;'."\n".
                                   '                try_files $uri @backend;'."\n".
                                        '        }'."\n".
                                        "\n".
                                '        location / '."\n".
                                        '        {'."\n".
                                   '                error_page 405 = @backend;'."\n".
//                                        '#           add_header X-Cache "HIT from Backend";'."\n".
                                   '                proxy_pass '.$proxy_pass.';'."\n".
                                   '                include "/etc/nginx/proxy/proxy.inc";'."\n".
                                   '                include "/etc/nginx/proxy/microcache.inc";'."\n".
                                        '        }'."\n".
                                        "\n".
                                '        location @backend '."\n".
                                        '        {'."\n".
                                   '                internal;'."\n".
                                   '                proxy_pass '.$proxy_pass.';'."\n".
                                   '                include "/etc/nginx/proxy/proxy.inc";'."\n".
                                   '                include "/etc/nginx/proxy/microcache.inc";'."\n".
                                '        }'."\n".
                                        "\n".
                                '        location ~ .*\.(php|jsp|cgi|pl|py)?$ '."\n".
                                        '        {'."\n".
                                   '                proxy_pass '.$proxy_pass.';'."\n".
                                   '                include "/etc/nginx/proxy/proxy.inc";'."\n".
                                   '                include "/etc/nginx/proxy/microcache.inc";'."\n".
                                        '        }'."\n".
                                        "\n".
                                        '   error_page 404 /404.html;'."\n".
                                        '       location = /40x.html {'."\n".
                                        '        }'."\n".
                                        "\n".
                                        '   error_page 500 502 503 504 /50x.html;'."\n".
                                        '        location = /50x.html {'."\n".
                                        '   }'."\n".                                        

                                        '}'."\n";
                        
                         file_put_contents(NGINX_CONF.$proxy_pass_host.'.https-cpl.conf', $out_https);
                         //echo $out_https;
                         $log.=date("m.d.y").' '.date("H:i:s").': done = '.$proxy_pass_host."\n";
                         // echo  'done = '.$proxy_pass_host."\n";
                        
                        // echo "\n----------------\n";
                        
                        // echo $virthost;                        
                        
                //        exit;
                }
                // цикл анализа текста для HTTPs
                // echo "\n";
        }        
        //print_r($mat);                        
        
        $log.=date("m.d.y").' '.date("H:i:s").': okonchanie'."\n";        
        $dt=getdate();
        // релоад конфига nginx
        exec('nginx -s reload',$output,$stat);
        if ($stat==1)
        {
                $log.=date("m.d.y").' '.date("H:i:s").': error reload nginx "'.$output.'"'."\n";
                
        } else
        {
                // запись данных о удачном прохождении
                file_put_contents(CPL_BASE.'nginx-cpl.dat', json_encode(array('ddt'=>$dt[0])));
        }
        // запись лога
        file_put_contents(CPL_BASE.'nginx-cpl.log', $log);
        }
}

